#pragma once
#include "Processor/file_processor.hpp"
#include "cd_file_types.hpp"

namespace JabyEngine {
    namespace FileProcessor {
        namespace Helper {
            template<typename T>
            static void simple_read(T& dst, State::Configuration& config) {
                static constexpr size_t T_SIZE = sizeof(T);

                dst = *reinterpret_cast<const T*>(config.data_adr);
                config.processed(T_SIZE);
            }

            template<typename T>
            static Progress exchange_and_execute_process_function(State::GenericProcessRoutine<T> process_routine, State::Configuration& config, T& state) {
                config.process_routine = reinterpret_cast<State::ProcessRoutine>(process_routine);
                return process_routine(config, state);
            }
        }
    }
}